/* $Id: blueglow.hpp,v 1.4 2005/10/06 13:33:56 chfreund Exp $ */

#ifndef _BLUEGLOW_HPP_
#define _BLUEGLOW_HPP_

/**********************************************************/

#include "noncollidableobject.hpp"

/**********************************************************/

class BlueGlow : public NonCollidableObject
{
	public:

		BlueGlow( World* wp, const Sint32 size = SMALLEST_BLUEGLOW );
		~BlueGlow() {}

		inline Sint32 getSize() const { return m_size; }
		inline void   setSize( const Sint32 size );

		//! returns the minimal choosable explosion size
		static Sint32 getMinSize() { return 0; }
		//! returns the maximal choosable explosion size
		static Sint32 getMaxSize() { return BIGGEST_BLUEGLOW - SMALLEST_BLUEGLOW; }
		//! returns object ID, built out of base ID + size
		Sint32 getID() const { return SMALLEST_BLUEGLOW + m_size; }
		//! updates the object
		void update();

		//! \name (de)serialization
		//@{
		virtual Uint32 getSerializeBufferSize() const;
		virtual void serialize( Uint8*& bufferPointer ) const;
		virtual void deserialize( Uint8*& bufferPointer );
		//@}

	protected:

		Sint32 m_size,
		       m_StepCounter;
};

/**********************************************************/

#endif // _BLUEGLOW_HPP_
