/* $Id: weaponhookrel.cpp,v 1.11 2005/12/04 17:15:24 pohlt Exp $ */

#include "weaponhookrel.hpp"
#include "world.hpp"
#include "avatar.hpp"
#include "rope.hpp"
#include "hook.hpp"

bool WeaponHookRel::reallyShoot( World* world, Avatar* avatar,
                                 const StationaryGun* gun ) const {
	Rope* rope = selectRopeForAction( avatar );
	if( ! rope ) {
		return false;
	}

	// place hook
	Hook* const hook = dynamic_cast<Hook*>( world->newObject( HOOK ));
	CollidableObject* hitObject;

	if( hook->initialize(
	       avatar->placeBesideCollRect(  hook->getCollRectX() + hook->getCollRectWidth() - 1,
	                                    -hook->getCollRectX(),
	                                     hook->getCollRectY() + hook->getCollRectHeight() - 1,
	                                    -hook->getCollRectY() ),
	       avatar->getRandomizedAimingVector( 5 )*(28.0 - 5.0 * world->getRandom().getNormedReal()) +
	       avatar->getVel(), hitObject ) == false ) {
		if( hitObject == NULL ) return false;
			// else hook could not be placed but an object was hit directly, so continue
	}
	else {
		// hook could be placed, so set hitObject to hook
		hitObject = hook;
	}

	// deattach rope from shooting avatar
	rope->detachFrom( avatar );
	// attach to new hook
	rope->attachTo( hitObject );
	

	return true;
}
