/* $Id: weaponshotgun.cpp,v 1.23 2005/10/21 08:02:53 pohlt Exp $ */

#include "weaponshotgun.hpp"
#include "world.hpp"
#include "avatar.hpp"

bool WeaponShotgun::reallyShoot( World* world, Avatar* avatar,
                                 const StationaryGun* gun ) const {
	const int N_BULLETS = 50;
	real power;

	// place bullet particles
	Vector startPos = avatar->placeBesideCollRect();

	for( int s = 0; s < N_BULLETS; s++ ) {
		power = 30.0 - 6.0 * world->getRandom().getNormedReal();
		world->getParticles()->addParticle( Particles::ParticleData(
				startPos,
				avatar->getRandomizedAimingVector( 20 )*power + avatar->getVel(),
		    Particles::EXPL_EARTH | Particles::EXPL_OBJECT | Particles::DAMAGE | Particles::EXPL_GEN_SPARKS,
		    0, avatar->getPlayer()->getPlayerID(), 100, 10, 0xffffff));
	}

	// apply recoil
	avatar->addForce( -avatar->getAimingVector() * N_BULLETS * power / world->getDT( avatar->getPos() ));

	return true;
}
